#!/bin/sh

SRCDIR=`pwd`
TEMP=`pwd`
VERSION=2.1.0
ROOT=repast.simphony
INSTALLATION=/opt/repast
ROOTA=$INSTALLATION/RepastTest2/MyModels
PLUGINS=$ROOTA/plugins
MANAGER=""

# Add to classpath

CP=$CP:$PLUGINS/libs.bsf_$VERSION/lib/*:$PLUGINS/libs.ext_$VERSION/lib/*:$PLUGINS/$ROOT.batch_$VERSION/lib/*
CP=$CP:$PLUGINS/$ROOT.batch_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.distributed.batch_$VERSION/lib/*
CP=$CP:$PLUGINS/$ROOT.distributed.batch_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.core_$VERSION/lib/*
CP=$CP:$PLUGINS/$ROOT.core_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.runtime_$VERSION/lib/*
CP=$CP:$PLUGINS/$ROOT.runtime_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.data_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.dataLoader_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.scenario_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.essentials_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.groovy_$VERSION/bin
CP=$CP:$PLUGINS/$ROOT.intergation_$VERSION/lib/*
CP=$CP:$PLUGINS/$ROOT.intergation_$VERSION/bin
CP=$CP:$PLUGINS/saf.core.ui_$VERSION/saf.core.v3d.jar
CP=$CP:$PLUGINS/saf.core.ui_$VERSION/lib/*
CP=$CP:$PLUGINS/libs/*
CP=$CP:$PLUGINS/JoSQL-2.2.jar
CP=$CP:$PLUGINS/jackson-all-1.9.0.jar
CP=$CP:$PLUGINS/log4j-api-2.1.jar
CP=$CP:$PLUGINS/portico.jar
CP=$CP:$PLUGINS/log4j-core-2.1.jar

now=$(date +"%D %T")
echo "Current Date and Time : $now"


if [ "$1" = "I" ]; then
		exit 0
fi

if [ "$1" = "R" ]; then
		exit 0
fi

if [ "$1" = "M" ]; then
	if [ ! -e $SRCDIR/federateslist.txt ]; then
		pwd
		ls -al
		echo "federateslist.txt not found"
		exit 1
	fi

	if [ ! -e $SRCDIR/batch_params.xml ]; then
		pwd
		ls -al
		echo "batch_params.xml not found"
		exit 1
	fi

	if [ ! -e $SRCDIR/model.tar ]; then
		pwd
		ls -al
		echo "model.tar not found"
		exit 1
	fi

	mkdir $SRCDIR/fManager
	cp $SRCDIR/federateslist.txt $SRCDIR/fManager
	cp $SRCDIR/batch_params.xml $SRCDIR/fManager
	cp $SRCDIR/model.tar $SRCDIR/fManager

	tar -cvf fManager.tar fManager
	rm -r $SRCDIR/fManager
	rm $SRCDIR/federateslist.txt
	rm $SRCDIR/batch_params.xml
	rm $SRCDIR/model.tar

	exit 0
fi

if [ "$1" != "" ]; then
	if [ ! -e $SRCDIR/batch_params.xml ]; then
		pwd
		ls -al
		echo "batch_params.xml not found"
		exit 1
	fi

	if [ ! -e $SRCDIR/model.tar ]; then
		pwd
		ls -al
		echo "model.tar not found"
		exit 1
	fi

	if [ -e $SRCDIR/input.tar ]; then
		MODEL_NAME=`tar -tf $SRCDIR/model.tar | head -1 | awk -F'/' '{ print $1 }'`

		tar -xf $SRCDIR/input.tar
		tar -xf $SRCDIR/model.tar
		rm $SRCDIR/model.tar

		cp -r $SRCDIR/input $SRCDIR/$MODEL_NAME

		tar -cvf model.tar $MODEL_NAME
		rm -r $SRCDIR/$MODEL_NAME
	fi

	mkdir $1
	cp $SRCDIR/batch_params.xml $SRCDIR/$1
	cp $SRCDIR/model.tar $SRCDIR/$1

	tar -cvf $1.tar $1
	rm -r $SRCDIR/$1
	rm $SRCDIR/batch_params.xml
	rm $SRCDIR/model.tar

	exit 0
fi

# Model directories
FEDERATENAME=fManager
FILENAME=$SRCDIR/$FEDERATENAME/federateslist.txt

if [ ! -e $SRCDIR/$FEDERATENAME.tar ]; then
    pwd
    ls -al
    echo "$FEDERATENAME not found"
    exit 1
fi

tar -xf $SRCDIR/$FEDERATENAME.tar

if [ ! -e $FILENAME ]; then
    pwd
    ls -al
    echo "federateslist.txt not found"
    exit 1
fi

mkdir $ROOTA/$FEDERATENAME
mkdir $INSTALLATION/RepastTest2/$FEDERATENAME
cp $SRCDIR/$FEDERATENAME/batch_params.xml $INSTALLATION/RepastTest2/$FEDERATENAME

(cd $ROOTA/$FEDERATENAME;tar -xf $SRCDIR/$FEDERATENAME/model.tar)

cat $FILENAME | while read LINE
do
    FEDERATENAME=$LINE

    if [ ! -e $SRCDIR/$FEDERATENAME.tar ]; then
    	pwd
    	ls -al
    	echo "$FEDERATENAME not found"
    	exit 1
    fi

    tar -xf $SRCDIR/$FEDERATENAME.tar

    mkdir $ROOTA/$FEDERATENAME
    mkdir $INSTALLATION/RepastTest2/$FEDERATENAME
    cp $SRCDIR/$FEDERATENAME/batch_params.xml $INSTALLATION/RepastTest2/$FEDERATENAME

    (cd $ROOTA/$FEDERATENAME;tar -xf $SRCDIR/$FEDERATENAME/model.tar)

done

FEDERATENAME=fManager
MODEL_NAME=`tar -tf $SRCDIR/$FEDERATENAME/model.tar | head -1 | awk -F'/' '{ print $1 }'`
MODEL_FOLDER=$ROOTA/$FEDERATENAME/$MODEL_NAME

CP=$CP:$MODEL_FOLDER/bin
CP=$CP:$MODEL_FOLDER/src

 (cd $MODEL_FOLDER;java -cp $CP repast.simphony.runtime.RepastBatchMain -params "$INSTALLATION/RepastTest2/$FEDERATENAME/batch_params.xml" "$MODEL_FOLDER/$MODEL_NAME.rs") &

cat $FILENAME | while read LINE
do
	if [ "$MANAGER" = "" ]; then
 		MANAGER=$LINE
		read LINE
	fi
   
    FEDERATENAME=$LINE
    MODEL_NAME=`tar -tf $SRCDIR/$FEDERATENAME/model.tar | head -1 | awk -F'/' '{ print $1 }'`
    MODEL_FOLDER=$ROOTA/$FEDERATENAME/$MODEL_NAME
echo $MODEL_FOLDER;
    CP=$CP:$MODEL_FOLDER/bin
    CP=$CP:$MODEL_FOLDER/src

    (cd $MODEL_FOLDER;java -cp $CP repast.simphony.runtime.RepastBatchMain -params "$INSTALLATION/RepastTest2/$FEDERATENAME/batch_params.xml" "$MODEL_FOLDER/$MODEL_NAME.rs") &
done

cat $FILENAME | while read LINE
do
	if [ "$MANAGER" = "" ]; then
 		MANAGER=$LINE
		FEDERATENAME=$LINE
		MODEL_NAME=`tar -tf $SRCDIR/$FEDERATENAME/model.tar | head -1 | awk -F'/' '{ print $1 }'`
		MODEL_FOLDER=$ROOTA/$FEDERATENAME/$MODEL_NAME

		CP=$CP:$MODEL_FOLDER/bin
		CP=$CP:$MODEL_FOLDER/src

		(cd $MODEL_FOLDER;java -cp $CP repast.simphony.runtime.RepastBatchMain -params "$INSTALLATION/RepastTest2/$FEDERATENAME/batch_params.xml" "$MODEL_FOLDER/$MODEL_NAME.rs")
   fi
done

mkdir $SRCDIR/output
FEDERATENAME=fManager
MODEL_NAME=`tar -tf $SRCDIR/$FEDERATENAME/model.tar | head -1 | awk -F'/' '{ print $1 }'`
MODEL_FOLDER=$ROOTA/$FEDERATENAME/$MODEL_NAME
    
mkdir $SRCDIR/output/$FEDERATENAME
cd $MODEL_FOLDER/output/
if find . -mindepth 1 -print -quit | grep -q .; then
	cp $MODEL_FOLDER/output/* $SRCDIR/output/$FEDERATENAME
fi

cat $FILENAME | while read LINE
do
    FEDERATENAME=$LINE
    MODEL_NAME=`tar -tf $SRCDIR/$FEDERATENAME/model.tar | head -1 | awk -F'/' '{ print $1 }'`
    MODEL_FOLDER=$ROOTA/$FEDERATENAME/$MODEL_NAME
    
    mkdir $SRCDIR/output/$FEDERATENAME
    cd $MODEL_FOLDER/output/
    if find . -mindepth 1 -print -quit | grep -q .; then
    	cp $MODEL_FOLDER/output/* $SRCDIR/output/$FEDERATENAME
    fi
done
    
cd $SRCDIR
tar -cf output.tar output

now=$(date +"%D %T")
echo "Current Date and Time : $now"

exit 0

